Imports System
Imports System.IO
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Navigation

' Add references to:
'   System.Printing
'   ReachFramework
Imports System.Windows.Shapes
Imports System.Windows.Media.Effects

Partial Public Class Window1
	Public Sub New()
		MyBase.New()

		Me.InitializeComponent()

		' Insert code required on object creation below this point.
	End Sub

    ' Print the window centered.
    Private Sub btnPrintCentered_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim pd As New PrintDialog()
        If pd.ShowDialog() Then
            PrintWindowCentered(pd, Me, "New Customer", Nothing)
        End If
    End Sub

    ' Print the window stretched to fit.
    Private Sub btnPrintStretched_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim pd As New PrintDialog()
        If pd.ShowDialog() Then
            PrintWindowCentered(pd, Me, "New Customer", New Thickness(50))
        End If
    End Sub

    ' Print a Window centered on the printer.
    Private Sub PrintWindowCentered(ByVal pd As PrintDialog, ByVal win As Window, ByVal title As String, ByVal margin As Thickness?)
        ' Make a Grid to hold the contents.
        Dim drawing_area As New Grid()
        drawing_area.Width = pd.PrintableAreaWidth
        drawing_area.Height = pd.PrintableAreaHeight

        ' Make a Viewbox to stretch the result if necessary.
        Dim view_box As New Viewbox()
        drawing_area.Children.Add(view_box)
        view_box.HorizontalAlignment = Windows.HorizontalAlignment.Center
        view_box.VerticalAlignment = Windows.VerticalAlignment.Center

        If margin Is Nothing Then
            ' Center without resizing.
            view_box.Stretch = Windows.Media.Stretch.None
        Else
            ' Resize to fit the margin.
            view_box.Margin = margin.Value
            view_box.Stretch = Windows.Media.Stretch.Uniform
        End If

        ' Make a VisualBrush holding an image of the Window's contents.
        Dim vis_br As New VisualBrush(win)

        ' Make a rectangle the size of the Window.
        Dim win_rect As New Rectangle()
        view_box.Child = win_rect
        win_rect.Width = win.Width
        win_rect.Height = win.Height
        win_rect.Fill = vis_br
        win_rect.Stroke = Brushes.Black
        win_rect.BitmapEffect = New DropShadowBitmapEffect()

        ' Arrange to produce output.
        Dim rect As New Rect(0, 0, _
            pd.PrintableAreaWidth, pd.PrintableAreaHeight)
        drawing_area.Arrange(rect)

        ' Print it.
        pd.PrintVisual(drawing_area, title)
    End Sub
End Class